class SeenAddressTable {
	struct Item {
		Item *next;
		unsigned long addr;
	};
	enum { size=521 };
	Item *e[size];
	unsigned hash(unsigned long addr) const { return (unsigned)(addr%size); }
public:
	SeenAddressTable();
	~SeenAddressTable();
	bool exists(unsigned long addr) const;
	void add(unsigned long addr);
	size_t count() const;
};

inline SeenAddressTable::SeenAddressTable() {
	for(size_t i=0; i<size; i++)
		e[i] = 0;
}

inline SeenAddressTable::~SeenAddressTable() {
	for(size_t i=0; i<size; i++) {
		Item *p=e[i];
		while(p) {
			Item *n=p->next;
			delete p;
			p=n;
		}
	}
}

bool SeenAddressTable::exists(unsigned long addr) const {
	unsigned i = hash(addr);
	for(Item *p=e[i]; p; p=p->next)
		if(p->addr==addr) return true;
	return false;
}

void SeenAddressTable::add(unsigned long addr) {
	unsigned i = hash(addr);
	for(Item *p=e[i]; p; p=p->next)
		if(p->addr==addr) return;
	Item *p = new Item;
	p->next = e[i];
	p->addr = addr;
	e[i] = p;
}
