class AddressObjectHashTable {
	struct Item {
		Item *next;
		Object *o;
		unsigned long addr;
	};
	enum { size=521 };
	Item *e[size];
	unsigned hash(unsigned long addr) { return (unsigned)(addr%size); }
public:
	AddressObjectHashTable();
	~AddressObjectHashTable();
	Object *find(unsigned long addr);
	void add(unsigned long addr, Object *);
	void forget(unsigned long addr);
};

inline AddressObjectHashTable::AddressObjectHashTable() {
	for(size_t i=0; i<size; i++)
		e[i] = 0;
}

inline AddressObjectHashTable::~AddressObjectHashTable() {
	for(size_t i=0; i<size; i++) {
		Item *p=e[i];
		while(p) {
			Item *n=p->next;
			delete p;
			p=n;
		}
	}
}

Object *AddressObjectHashTable::find(unsigned long addr) {
	unsigned i = hash(addr);
	for(Item *p=e[i]; p; p=p->next)
		if(p->addr==addr) return p->o;
	return 0;
}

void AddressObjectHashTable::add(unsigned long addr, Object *o) {
	unsigned i = hash(addr);
	Item * p = new Item;
	p->next = e[i];
	p->o = o;
	p->addr = addr;
	e[i] = p;
}

void AddressObjectHashTable::forget(unsigned long addr) {
	unsigned i = hash(addr);
	for(Item *p=e[i],*pp=0; p; pp=p,p=p->next) {
		if(p->addr==addr) {
			if(pp)
				pp->next = p->next;
			else
				e[i] = p->next;
			delete p;
			return;
		}
	}
}
