#define __STDC_FORMAT_MACROS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "evrecord.h"
#include "ev.h"
#include "logread.h"

bool ReadLog(const char *log_filename, EventRecord **erpp, size_t *records) {
	FILE *fp = fopen(log_filename,"r");
	if(!fp) return false;
	setvbuf(fp,0,_IOFBF,32768);
	
	EventRecord *e=0;
	size_t n=0;
	size_t a=0;

	char line[128];
	while(fgets(line,(int)sizeof(line),fp)) {
		if(n==a) {
			if(a<1024)
				a = 1024;
			else
				a = a + a/2;
			e = (EventRecord*)realloc(e,sizeof(EventRecord)*a);
			if(!e) {
				fprintf(stderr,"out of memory\n");
				fclose(fp);
				return false;
			}
		}
		unsigned long timestamp_sec;
		unsigned long timestamp_usec;
		sscanf(line,"%lx %lu.%lu %d %*[^ ] %lx %lx %ld",
		       &e[n].tid,
		       &timestamp_sec,
		       &timestamp_usec,
		       &e[n].event,
		       &e[n].mtx_addr,
		       &e[n].cond_addr,
		       &e[n].info
		      );
		if(e[n].event==ev_thread_name ||
		   e[n].event==ev_mutex_name ||
		   e[n].event==ev_cond_name)
		{
			char name[512];
			sscanf(line,"%lx %lu.%lu %d %*[^ ] %lx %lx %s",
			       &e[n].tid,
			       &timestamp_sec,
			       &timestamp_usec,
			       &e[n].event,
			       &e[n].mtx_addr,
			       &e[n].cond_addr,
			       name
			      );
			size_t namelen=strlen(name);
			char *pname = (char*)malloc(namelen+1);
			memcpy(pname,name,namelen+1);
			e[n].name = pname;
		}
		e[n].timestamp = timestamp_sec + timestamp_usec/1000000.0;
		n++;
		if((n%32768)==0) {
			printf("\nRead %ld records...",(long)n);
			fflush(stdout)	;
		}
	}
	fclose(fp);
	*erpp = e;
	*records = n;
	printf("\nRead %ld records...",(long)n);
	return true;
}
