#include "mta_naming.h"
#include <pthread.h>
#include <dlfcn.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h> /*sprintf only*/
#include <sys/time.h>
#include <string.h>
#include "ev.h"
#include "evnames.h"

#ifdef POINTERSARE64BIT
#define PTRFORMAT "016lx"
#else
#define PTRFORMAT "08lx"
#endif

static int fd_log=-1;
static void logName(event_t ev, pthread_mutex_t *pmtx, pthread_cond_t *pcond, const char *name) {
	char buf[512];
	struct timeval tv_now;
	pthread_t tid;
	if(fd_log<0) {
		fd_log = open("mta.log",O_WRONLY|O_CREAT|O_APPEND, 0644);
		if(fd_log<0) return;
	}
	gettimeofday(&tv_now,0);
	tid = pthread_self();
	sprintf(buf,"%"PTRFORMAT" %10ld.%06ld %2d %s %"PTRFORMAT" %"PTRFORMAT" %s\n",(long)tid,tv_now.tv_sec,tv_now.tv_usec,ev,ev_name[ev],(long)pmtx,(long)pcond,name);
	write(fd_log,buf,strlen(buf));
}

#ifdef __cplusplus
extern "C" {
#endif

void mtanalyze_name_mutex(pthread_mutex_t *pmtx, const char *name) {
	logName(ev_mutex_name,pmtx,0,name);
}
void mtanalyze_name_condition(pthread_cond_t *pcond, const char *name) {
	logName(ev_cond_name,0,pcond,name);
}
void mtanalyze_name_thread(const char *name) {
	logName(ev_thread_name,0,0,name);
}

#ifdef __cplusplus
}
#endif
