#include <pthread.h>
#include <stdio.h>
#include <unistd.h>

#include "mta_naming.h"

static pthread_mutex_t mtx_1 = PTHREAD_MUTEX_INITIALIZER;

extern "C" void *threadfunc(void *pv) {
	mtanalyze_name_thread("threadfunc");
	pthread_cond_t *pcond=(pthread_cond_t *)pv;
	
	pthread_mutex_lock(&mtx_1);
	pthread_cond_wait(pcond,&mtx_1);
	pthread_mutex_unlock(&mtx_1);
	return 0;
}

int main(void) {
	mtanalyze_name_thread("main thread");
	mtanalyze_name_mutex(&mtx_1,"mtx_1 (global)");
	
	printf("In main()\n");
	pthread_mutex_lock(&mtx_1);
	printf("locked\n");
	pthread_mutex_unlock(&mtx_1);
	printf("unlocked\n");
	
	printf("Creating cond...\n");
	pthread_cond_t cond;
	pthread_cond_init(&cond,0);
	mtanalyze_name_condition(&cond,"cond (on stack)");
	
	printf("Creating thread...\n");
	pthread_t tid;
	pthread_create(&tid,0,threadfunc,&cond);
	sleep(1);
	pthread_cond_signal(&cond);
	printf("Joining thread...\n");
	pthread_join(tid,0);
	
	return 0;
}
