#include <pthread.h>
#include <stdio.h>
#include <unistd.h>

static bool shutdown_now=false;
static pthread_mutex_t mtx = PTHREAD_MUTEX_INITIALIZER;
static pthread_cond_t cond = PTHREAD_COND_INITIALIZER;

extern "C" void *threadfunc(void *) {
	pthread_mutex_lock(&mtx);
	while(!shutdown_now)
		pthread_cond_wait(&cond,&mtx);
	pthread_mutex_unlock(&mtx);
	return 0;
}

#define THREADS 2

int main(void) {
	pthread_t tid[THREADS];
	for(int i=0; i<THREADS; i++)
		pthread_create(&tid[i],0,threadfunc,0);
	sleep(1);
	for(int j=0; j<3; j++) {
		pthread_mutex_lock(&mtx);
		if(j==2) shutdown_now=true;
		pthread_cond_broadcast(&cond);
		pthread_mutex_unlock(&mtx);
		sleep(1);
	}
	for(int i=0; i<THREADS; i++)
		pthread_join(tid[i],0);
	
	return 0;
}
